import java.awt.event.*;
import javax.swing.JMenuItem;

public class ElementMenuListener implements ActionListener {
   private MyWorld  world;
   public ElementMenuListener (MyWorld  w){
      world = w;
   }
   public void actionPerformed(ActionEvent e) {
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      String text = menuItem.getText();
      if (text.equals("Delete")) 
    	  world.setCursor();
      if (text.equals("Ball")) 
    	  new GBall(1f, 0.2f, new Vector2D(2f,1f),new Vector2D(2*Math.random(),2*Math.random()), world);
      if (text.equals("Wall Sideways")) 
    	  new GWall(new Vector2D(2f,3f), Wall.SIDEWAYS, 4f, world);
      if (text.equals("Wall Straight")) 
    	  new GWall(new Vector2D(2f,3f), Wall.STRAIGHT, 4f, world);
      if (text.equals("Scenario")){
    	  new GWall(new Vector2D(0f,0f), Wall.SIDEWAYS, 4f, world);
          new GWall(new Vector2D(0f,4f), Wall.SIDEWAYS, 4f, world);
          new GWall(new Vector2D(0f,0f), Wall.STRAIGHT, 4f, world);
          new GWall(new Vector2D(4f,0f), Wall.STRAIGHT, 4f, world);
    	  for (int i=0; i<20; i++)
    		  new GBall(1f, 0.2f, new Vector2D(0.5+3*Math.random(),0.5+3*Math.random()),new Vector2D(2*Math.random(),2*Math.random()), world);
      }
      if(text.equals("Pool")){ //Escenario alternativo
    	  world.setViscosity(0.1f);
    	  world.setGravity(new Vector2D(0.0,0.0));
    	  new GWall(new Vector2D(0.4f,0f), Wall.SIDEWAYS, 4.8f, world);
          new GWall(new Vector2D(0.4f,3.2f), Wall.SIDEWAYS, 4.8f, world);
          new GWall(new Vector2D(0f,0.4f), Wall.STRAIGHT, 2.5f, world);
          new GWall(new Vector2D(5.6f,0.4f), Wall.STRAIGHT, 2.5f, world);
    	  for (int i=0; i<16; i++){
    		  switch(i){
    		  case (0): new GBall(1f, 0.15f, new Vector2D(1.1,1.1),new Vector2D(0.0,0.0), world, "Yellow"); break;
    		  case (1): new GBall(1f, 0.15f, new Vector2D(1.1,1.4),new Vector2D(0.0,0.0), world, "Blue"); break;
    		  case (2): new GBall(1f, 0.15f, new Vector2D(1.1,1.7),new Vector2D(0.0,0.0), world, "Red"); break;
    		  case (3): new GBall(1f, 0.15f, new Vector2D(1.1,2.0),new Vector2D(0.0,0.0), world, "Cyan"); break;  
    		  case (4): new GBall(1f, 0.15f, new Vector2D(1.1,2.3),new Vector2D(0.0,0.0), world, "Magenta"); break;
    		  case (5): new GBall(1f, 0.15f, new Vector2D(1.4,2.25),new Vector2D(0.0,0.0), world, "Green"); break;
    		  case (6): new GBall(1f, 0.15f, new Vector2D(1.4,1.95),new Vector2D(0.0,0.0), world, "Orange"); break;
    		  case (7): new GBall(1f, 0.15f, new Vector2D(1.4,1.6),new Vector2D(0.0,0.0), world, "Black"); break;
    		  case (8): new GBall(1f, 0.15f, new Vector2D(1.4,1.25),new Vector2D(0.0,0.0), world, "Yellow"); break;
    		  case (9): new GBall(1f, 0.15f, new Vector2D(1.7,2.0),new Vector2D(0.0,0.0), world, "Blue"); break;
    		  case (10): new GBall(1f, 0.15f, new Vector2D(1.7,1.7),new Vector2D(0.0,0.0), world, "Red"); break;
    		  case (11): new GBall(1f, 0.15f, new Vector2D(1.7,1.4),new Vector2D(0.0,0.0), world, "Cyan"); break;
    		  case (12): new GBall(1f, 0.15f, new Vector2D(2.0,1.9),new Vector2D(0.0,0.0), world, "Magenta"); break;
    		  case (13): new GBall(1f, 0.15f, new Vector2D(2.0,1.6),new Vector2D(0.0,0.0), world, "Green"); break;
    		  case (14): new GBall(1f, 0.15f, new Vector2D(2.3,1.7),new Vector2D(0.0,0.0), world, "Orange"); break;
    		  case (15): new GBall(1f, 0.15f, new Vector2D(5.2,1.7),new Vector2D(-5.0,0.0), world, "White"); break;
    		  }
    	  }
      }
   }
}