import java.awt.*;
import java.awt.geom.*;
class GBall extends Ball implements Drawable {
   private Color color = Color.BLUE;
   private Ellipse2D.Float shape = null;
   public GBall (float mass, float r, Vector2D position, Vector2D speed, MyWorld world){
      super(mass, r, position, speed, world);
      shape = new Ellipse2D.Float((float)getX()-r, (float)getY()-r, 2*r, 2*r);
   }
   public GBall (float mass, float r, Vector2D position, Vector2D speed, MyWorld world, String color){ //Constructor con color
	   this(mass, r, position, speed, world);
	   setColor(color);
	   shape = new Ellipse2D.Float((float)getX()-r, (float)getY()-r, 2*r, 2*r);
   }
   public void draw (Graphics2D g){
      shape.setFrame((float)getX()-radius, (float)getY()-radius, 2*radius, 2*radius);
      g.setColor(color);
      g.fill(shape);
   }
   public boolean contains (double x, double y){
      return shape.contains(x,y);
   }
   public void dragTo(double x, double y){
      setPosition(x,y);
   }
   public void setSelected (){
   }
   public void setReleased() {
   }
   public void setColor(String color){ //Convierte String a Color
	   if(color.equals("White")) this.color=Color.WHITE;
	   else if(color.equals("Black")) this.color=Color.BLACK; 
	   else if(color.equals("Yellow")) this.color=Color.YELLOW;
	   else if(color.equals("Red")) this.color=Color.RED;
	   else if(color.equals("Green")) this.color=Color.GREEN;
	   else if(color.equals("Blue")) this.color=Color.BLUE;
	   else if(color.equals("Orange")) this.color=Color.ORANGE;
	   else if(color.equals("Cyan")) this.color=Color.CYAN;
	   else if(color.equals("Magenta")) this.color=Color.MAGENTA;
	}
}