import javax.swing.*;
import java.awt.event.*;
import java.awt.geom.Point2D;
import java.awt.*;

public class MouseListener extends MouseAdapter {
   private MyWorld world;
   private Drawable currentElement;
   private JPanel panel;
   private PhysicsElement element;
   private GBall gball;
   private JComboBox colorMenu; 
   private boolean edit=false;
   private Point2D.Double punto;
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;
   } 
   public void mouseMoved(MouseEvent e) {
      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      Drawable newElement = world.find(p.getX(), p.getY());
      if (newElement == currentElement){
			if(currentElement instanceof GWall && panel.getCursor().getType()!=Cursor.CROSSHAIR_CURSOR)
				if(Math.abs((float)(p.getX()-((GWall)currentElement).getX()-((GWall)currentElement).getLength()))<.1)
					 	panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
         	else
					if(Math.abs((float)(p.getY()-((GWall)currentElement).getY()-((GWall)currentElement).getLength()))<.1)
					 	panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
         	else
					panel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

			return;
		}

      if (currentElement != null) {
    	  currentElement.setReleased();
    	  
		  if(currentElement instanceof GWall && panel.getCursor().getType()!=Cursor.CROSSHAIR_CURSOR)
		  	panel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	  currentElement = null;
      }
      if (newElement != null) { 
         currentElement = newElement;
         currentElement.setSelected();
	 if(currentElement instanceof GWall && panel.getCursor().getType()!=Cursor.CROSSHAIR_CURSOR){
				if(Math.abs((float)(p.getX()-((GWall)currentElement).getX()-((GWall)currentElement).getLength()))<.1)
					 	panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
				if(Math.abs((float)(p.getY()-((GWall)currentElement).getY()-((GWall)currentElement).getLength()))<.1)
					 	panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
			}
        	 		
      				
      	}
      panel.repaint();
   }
   
   public void mouseDragged(MouseEvent e) {
	   Point2D.Double p = new Point2D.Double(0,0);
	   MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
	   if (currentElement == null) return;
	   if(currentElement instanceof GWall){
		   GWall wall = (GWall)currentElement;
	       if(Math.abs((float)(p.getX()-wall.getX()-wall.getLength()))<.1){ //Verifica si está en un extremo de la barra
	    	   if (!edit){ punto = new Point2D.Double(wall.getX(),wall.getY());
	    	   panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
	    	   }
	    	   edit=true;
	       }
	       if(Math.abs((float)(p.getY()-wall.getY()-wall.getLength()))<.1){ //Verifica si está en el otro extremo
	    	   if (!edit){ 
	    		   punto = new Point2D.Double(wall.getX(),wall.getY());
	    		   panel.setCursor(Cursor.getPredefinedCursor(Cursor.NE_RESIZE_CURSOR));
	    	   }
	    	   edit=true;   
	       }
	       switch (wall.orientation){ //Revisa el tipo de pared
	       case Wall.SIDEWAYS: 
	    	   if(edit)
	    		   wall.setLength(p,punto);
	    	   else
	    		   currentElement.dragTo(p.getX(), p.getY());
	    	   break;
	       case Wall.STRAIGHT: 
	    	   if(edit)
	    		   wall.setLength(p,punto);
	    	   else
	    		   currentElement.dragTo(p.getX(), p.getY());
	    	   break;
	       }
	       panel.repaint();
	       return;
	   }
	   currentElement.dragTo(p.getX(), p.getY());
	   panel.repaint();
   }	
   public void mouseClicked(MouseEvent e){
	   Point2D.Double p = new Point2D.Double(0,0);
	   MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
	   Drawable newElement = world.find(p.getX(), p.getY());
	   element = (PhysicsElement) newElement;
	   if(panel.getCursor().getType()==Cursor.CROSSHAIR_CURSOR){
		   if (currentElement != null && e.getClickCount() >= 1)
			   world.removeElement(element);
		   world.resetCursor();
	   }
	   if (e.isMetaDown() && newElement!=null && newElement instanceof GBall){ //Revisa si hace click derecho sobre una bola
		   gball = (GBall) newElement;
		   String [] colors = {"...","White","Black","Yellow","Red",
				   "Green","Blue","Orange","Cyan","Magenta"}; 
		   colorMenu=new JComboBox(colors); 
		   JTextField weightField = new JTextField(7);
		   JTextField radiusField = new JTextField(7);		   
		   JPanel subpanel = new JPanel();
		   subpanel.add(new JLabel("Color:"));
		   subpanel.add(colorMenu);
		   subpanel.add(Box.createHorizontalStrut(15)); // a spacer
		   subpanel.add(new JLabel("Weight [Kg]:"));
		   subpanel.add(weightField);
		   subpanel.add(Box.createHorizontalStrut(15)); // a spacer
		   subpanel.add(new JLabel("Radius [m]:"));
		   subpanel.add(radiusField);
		   colorMenu.addActionListener(new ActionListener() { //Revisa eligió un color
			   public void actionPerformed(ActionEvent ie){
				   gball.setColor((String)colorMenu.getSelectedItem());
			   }
		   });
		   int result = JOptionPane.showConfirmDialog(null, subpanel, //Desplega las opciones
				   "Please Enter Values", JOptionPane.OK_CANCEL_OPTION);
		   if(result == JOptionPane.OK_OPTION){ 
			   if(!weightField.getText().equals("")){ //Asigna opciones
				   if(Float.valueOf(weightField.getText())>0) gball.setWeight(Float.valueOf(weightField.getText()));
			   }
			   if(!radiusField.getText().equals("")){
				   if(Float.valueOf(radiusField.getText())>0) gball.setRadius(Float.valueOf(radiusField.getText()));
			   }
		   }
		   panel.repaint();
	   }  
   }
   public void mouseReleased(MouseEvent e) {
	   Point2D.Double p = new Point2D.Double(0,0);
	   MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
	   if (currentElement != null) {
		   if(currentElement instanceof GWall && edit== true){ //Si se editó, se refresca
			   currentElement.setReleased();
			   if((float)(p.getX()-((GWall)currentElement).getX())<0) //Si fue un cambio hacia la izquierda
				   currentElement.dragTo(p.getX(), p.getY());
			   panel.repaint();
			   panel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			   edit=false;
		   }
	   }
   }
}
