import java.awt.event.*;
import javax.swing.JOptionPane;
import javax.swing.JMenuItem;
import javax.swing.*;

public class WorldControlMenuListener implements ActionListener {
	private MyWorld world;
	private JPanel fondo;
	private JFrame frame;
	private JSplitPane panelPrincipal;
	public WorldControlMenuListener (MyWorld w, JPanel p, JFrame f, JSplitPane sp){
		world = w;
		fondo = p;
		frame = f;
		panelPrincipal = sp;
	}
	public void actionPerformed(ActionEvent e) {
		String data;
		JMenuItem menuItem = (JMenuItem)(e.getSource());
		String text = menuItem.getText();
		if (text.equals("Start"))   world.start();
		if (text.equals("Stop"))    world.stop();
		if (text.equals("Gravity")) {
			try {
				data = JOptionPane.showInputDialog("Enter Gravity [m/s^2]");
				world.setGravity(new Vector2D(0,Float.parseFloat(data)));
			} catch ( NumberFormatException ex) {
				world.setGravity(new Vector2D(0,0));
			}
		}
		if (text.equals("Viscosity")) { 
			try {
				data = JOptionPane.showInputDialog("Enter Viscosity [kg/(sm)]");
				world.setViscosity(Float.parseFloat(data));
			} catch ( NumberFormatException ex) {
				world.setViscosity(0f);
			}
		}
		if (text.equals("Delta time")){ 
			try {
				data = JOptionPane.showInputDialog("Enter delta t [s]");
				world.setDelta_t(Float.parseFloat(data));
			} catch ( NumberFormatException ex) {
				world.setDelta_t(MyWorld.DEFAUL_DELTA);
			}
		}
		if (text.equals("Graphics Refresh time")){ 
			try {
				data = JOptionPane.showInputDialog("Enter refresh time [s]");
				world.setRefreshPeriod(Float.parseFloat(data));
			} catch ( NumberFormatException ex) {
				world.setRefreshPeriod(MyWorld.DEAFAUL_REFRESH);
			}
		}
		if (text.equals("On")){ //Opciones de Ploteo
			frame.setSize(MyWorld.WIDTH*2, MyWorld.HEIGHT+50);
			panelPrincipal.setDividerLocation(MyWorld.WIDTH);
			fondo.setVisible(true);
			world.Grafica_reset();
		} 
		if (text.equals("Off")){
			frame.setSize(MyWorld.WIDTH, MyWorld.HEIGHT+50);						
			fondo.setVisible(false);	
	}
	}
}
